/*
 * Verarbeite eine Konfigurationsdatei
 *
 * Das meiste lesen wir einfach in ein Array. Besondere Behandlung er-
 * fahren:
 *    Alias        <url-path> <real-path>
 *    ScriptAlias  <url-path> <real-path>
 */

#ifndef __HTTP_CONFIG_H__
#define __HTTP_CONFIG_H__

#ifdef _REENTRANT
#include <pthread.h>
#endif

class HttpConfig {
public:
  HttpConfig  (void);
  ~HttpConfig (void);

  void put  (const char *, const char *, int type=0);
  void load (const char *);

  void AddAlias       (const char *, const char *);
  void AddScriptAlias (const char *, const char *);

  const char *  operator[] (const char *);
        char *  ParseURL   (const char *, int * = NULL, int = 0);
	char ** PassEnviron(char ** = NULL);
        int     Uploadable (const char *);

private:
  enum {
    NONE = 0,
    ALIAS,
    SCRIPT_ALIAS
  };

private:
  struct myll {
    const char * attrib;
    const char * value;
    int type;
    struct myll * next;
  };
  myll * conf;

#ifdef _REENTRANT
  static pthread_mutex_t mutex;
#endif
};

#endif
