/*
 * Bediene einen HTTP Request
 */

#ifndef __HTTP_REQUEST_H__
#define __HTTP_REQUEST_H__

#include <stdio.h>
#include <stdarg.h>
#include "fpSocket.h"
#include "HttpServer.h"
#include "HttpHeader.h"

/*
 * Request-Klasse
 */

class HttpRequest {
public:
  HttpRequest  (fpSocket *, HttpServer * = NULL);
  ~HttpRequest (void);

  int serve    (void);

private:
  enum {
    HTTP_GET,
    HTTP_HEAD,
    HTTP_POST,
    HTTP_PUT,
    HTTP_DELETE
  };

  long DumpFile  (FILE *);
  void DumpError (const char *);

  void ServeScript (void);
  void ServeGet    (void);
  void ServePost   (void);
  void ServePut    (void);
  void ServeDelete (void);

  void PrintLog  (const char *, ...);
  void AccessLog (int, long);

  int script;
  int method;
  int httpvers;
  char mname[32];
  char * origURL;
  char * targetURL;
  char * decodedURL;
  fpSocket * sock;
  HttpServer * master;
  HttpHeader headers;

  /*
   * Zaehler
   */

  int instance;
  static int counter;
};

#endif
