/*
 * HTTP Server
 */

#ifndef __HTTP_SERVER_H__
#define __HTTP_SERVER_H__

#ifdef _REENTRANT
#include <pthread.h>
#endif

#include <stdio.h>
#include <stdarg.h>
#include "HttpConfig.h"
#include "MimeTypes.h"
#include "fpSocket.h"

/*
 * Serverklasse
 */

class HttpServer {
public:
  HttpServer  (const char * = NULL, FILE * = NULL);
  ~HttpServer (void);

  int serve   (u_short = 0);

  /*
   * Konfigurationsdaten sind public
   */

  HttpConfig conf;
  MimeTypes  mime;

  friend class HttpRequest;

  static const char * ServerName;

  static int logrequests;

private:
  void PrintLog  (const char *, ...);

  u_short portno;

  FILE * log;
  FILE * transfer_log;

#ifdef _REENTRANT

  /*
   * Wir brauchen eine statische Funktion fuer pthread_create
   */

  struct blubber {
    fpSocket * conn;
    HttpServer * master;
  };

  static void * service (void *);

  /*
   * Mutex zum Schuetzen der Logfiles
   */

  pthread_mutex_t mutex;

#endif
};

#endif
