/*
 * Eine etwas erweiterte Socket-Klasse
 */

#ifndef __FP_SOCKET_H__
#define __FP_SOCKET_H__

#include <socket_class.h>
#include <stdarg.h>

#ifdef _REENTRANT
#include <pthread.h>
#endif


class fpSocket : public c_socket_str {
public:
  fpSocket (void);
  fpSocket (c_address &);
  fpSocket (c_socket_str &);
  fpSocket (fpSocket &);

  fpSocket * accept (void);

  int    fgetc   (void);
  int    ungetc  (int);
  int    read    (void *, int);
  char * fgets   (char *, int);
  int    printf  (const char *, ...);

  /*
   * Reentrante Funktionen zum Zugriff auf das Adressobjekt
   */

  char * gethostname_r (char *, size_t) const;
  char * getinetaddr_r (char *, size_t) const;
  u_long getnetaddr_r  (void) const;

private:
  int ungot, ungotc;

#ifdef _REENTRANT

  /*
   * Mutex zum Schuetzen des Adressobjektes
   */

  static pthread_mutex_t mutex;

#endif
};

#endif
